/******************************************************************************

Coral Tree iws/btnbar.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <iws/btnbar.h>

/***********************************************************************
class IWS_ButtonBar
***********************************************************************/
IWS_ButtonBar::IWS_ButtonBar(void)
{
	SetMode(WDS_FORM_SINGLE_ROW);
	SetUniformity(WDS_UNIFORM_BOTH);
	SetSizing(WDS_HORIZONTAL, WDS_SIZING_MANUAL);
	SetSizing(WDS_VERTICAL, WDS_SIZING_FIT_CHILDREN);
	SetCentering(WDS_FORM_CENTER_X);
}

IWS_ButtonBar::~IWS_ButtonBar(void)
{
}

IWS_Button *IWS_ButtonBar::AddButton(const GPL_String & n,
										IWS_Handler *handler,
										WDS_Activation *actv)
{
	IWS_Button *button = new IWS_Button();
	button->SetName(n.GetData ());
	button->SetLabel(n.GetData ());

	if ((IWS_Handler *) GPL_BAD_ADDRESS != handler)
	{
		button->SetHandler(handler, actv);
	}
	AddWidget(button);
	return button;
}

WDS_Button *IWS_ButtonBar::FindButton(const GPL_String & n)
{
	EW_WidgetList *list = GetWidgetList();
	WDS_Button *button = (WDS_Button *) GPL_BAD_ADDRESS;
	list->ToHead();
	/* ASSUMING AT LEAST A WDS_Widget */
	WDS_Widget *widget;
	while(widget = (WDS_Widget *)(list->PostIncrement()))
	{
		if( widget->GetTypeCode() == WDS_Button::GetTypeCodeStatic() )
		{
			if(n == widget->GetName())
			{
				button = (WDS_Button *)widget;
				break;
			}
		}
	}
	return button;
}

/***********************************************************************
class IWS_ButtonColumn
***********************************************************************/
IWS_ButtonColumn::IWS_ButtonColumn(void)
{
	SetMode(WDS_FORM_SINGLE_COLUMN);
	SetSizing(WDS_VERTICAL, WDS_SIZING_MANUAL);
	SetSizing(WDS_HORIZONTAL, WDS_SIZING_FIT_CHILDREN);
	SetCentering(WDS_FORM_CENTER_Y);
}
