#ifndef IWS_GETSTR_H
#define IWS_GETSTR_H

/******************************************************************************

Coral Tree iws/getstr.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <iws/handler.h>
#include <iws/align.h>

class IWS_DefaultGetStringHandler : public IWS_Handler
{
	public:
		IWS_DefaultGetStringHandler(){}
virtual ~IWS_DefaultGetStringHandler(){}

virtual	void HandleEvent(const GPL_String &string)
		{
			wbaLog("IWS WARNING", "[%s] getstring not handled", 
				(const char *)string);
		}		
};

class IWS_DefaultStringListHandler : public IWS_Handler
{
	public:
		IWS_DefaultStringListHandler(){}
virtual ~IWS_DefaultStringListHandler(){}

virtual	void HandleEvent(const GPL_String &string)
		{
			wbaLog("IWS WARNING", "[%s] string list not handled", 
				(const char *)string);
		}		
};

/***********************************************************************
class IWS_GetString
***********************************************************************/
class IWS_GetString : public WDS_GetString, public IWS_AnnotationAlignable
{
	private:
		static IWS_DefaultGetStringHandler	defaultHandler;
		IWS_GetString(const IWS_GetString &getString);
		IWS_GetString &operator=(const IWS_GetString &getString);

	public:
		IWS_GetString(const GPL_String &n,const long tw=-1,const long th=-1,
						const long aw = -1, const long ah = -1);
		IWS_GetString(const long tw = -1, const long th = -1,
						const long aw = -1, const long ah = -1);
		void IWS_GetStringConstructor(const long tw, const long th,
						const long aw, const long ah);
virtual	~IWS_GetString();

		void SetText(const char *text);

virtual	const char *GetText(void);
		IWS_AnnotationAlignable_DECLARATION();

virtual	void SetHandler(IWS_Handler *handler, WDS_Activation *actv = NULL);
};

class IWS_StringList : public WDS_Form
{
	private:
		static IWS_DefaultStringListHandler	defaultHandler;
		IWS_StringList(const IWS_StringList &textList);
		IWS_StringList &operator=(const IWS_StringList &textList);
	protected:
		WDS_ScrollRegion *scrollRegion;
		WDS_TextList	*textList;
		WDS_StringList	*strings;

		void UpdateSize(void);
	public:
		IWS_StringList(void);
		IWS_StringList(const GPL_String &n);
		void IWS_StringListConstructor(void);
virtual	~IWS_StringList(void);

		WDS_TextList *GetTextList(void) { return textList; }
		char *GetSelectedString();

		void AddText(const char *text, long style = WDS_STRING_STYLE_NULL);
		void Clear(void);
		void Dump(void);
		void SetHandler(IWS_Handler *handler, WDS_Activation *actv = NULL);
};

#endif /* IWS_GETSTR_H */
