#ifndef IWS_PICK_H
#define IWS_PICK_H

/******************************************************************************

Coral Tree iws/pick.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <iws/handler.h>
#include <iws/align.h>

/***********************************************************************
class IWS_PickHandler
***********************************************************************/
class IWS_PickHandler : public IWS_Handler
{
	public:
		IWS_PickHandler(void) {}
		virtual ~IWS_PickHandler(void) {}

		virtual void SetString(GPL_String &string);
};

/***********************************************************************
class IWS_DefaultPickHandler
***********************************************************************/
class IWS_DefaultPickHandler : public IWS_PickHandler
{
	public:
		virtual void HandleEvent(const GPL_String &string)
		{
			wbaLog("IWS WARNING", "[%s] picklist not handled", 
				(const char *)string);
		}
};

/***********************************************************************
class IWS_Pick
***********************************************************************/
class IWS_Pick : public WDS_Pick, public IWS_AnnotationAlignable
{
	public:
		IWS_Pick(const GPL_String & n, const long tw = -1, const long th = -1,
					const long aw = -1, const long ah = -1);
		IWS_Pick(const long tw = -1, const long th = -1,
					const long aw = -1, const long ah = -1);
		virtual ~IWS_Pick(void);

		void IWS_PickConstructor(const long tw, const long th,
									const long aw, const long ah);

		void AppendEntry(const GPL_String & n);
		void ClearEntries(void);
		long RemoveEntry(const GPL_String & n);

		const GPL_String & GetSelected(void);

		virtual void SetHandler(IWS_PickHandler *handler,
								WDS_Activation *actv =
								(WDS_Activation *) GPL_BAD_ADDRESS);

		virtual const char *GetText(void);
		IWS_AnnotationAlignable_DECLARATION();

	protected:
		GPL_String selected;

	private:
		static IWS_DefaultPickHandler defaultHandler;
};

#endif /* IWS_PICK_H */
