
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <iws/iws.h>

IWS_MenuPopup::IWS_MenuPopup(WDS_Widget *v)
{
	if(v)
	{
		SetTarget(v);
	}

	SetGeneralFlags(WDS_WIDGET_FLAGS_NONE);
    SetMenuFlags(WDS_MENU_FLAGS_NONE);
}

IWS_MenuPopup::~IWS_MenuPopup()
{
}

long IWS_MenuPopup::Resize(EW_Resize *resize)
{
	long x,y,w,h;
	target->GetTrueGeometry(&x,&y,&w,&h);

#if TRUE
	SetTrueOrigin(x,y);
	SetPrefSize(w,h);

	return WDS_MenuNode::Resize(resize);
#else
	SetGeometry(x,y,w,h);
	return 0;
#endif
}

void IWS_MenuPopup::SetTarget(WDS_Widget *target_widget)
{
	if(target)
	{
		if(GetRootWindow())
		{
			GetRootWindow()->RemoveWidget(this);
		}
	}
	target = target_widget;
	if(target->GetRootWindow())
	{
		IWS_Window *w = (IWS_Window *)(target->GetRootWindow());
		w->rootScope->AddWidget(this, EW_ADD_BEGINNING);	
	}
	SetBounds(EW_BOUNDS_IGNORE_PARENT);
	SetLocation(WDS_POPUP_LOC_MOUSE);
	SetPopItem(EW_ITEM_RIGHT);
	SetFlags(WDS_POPUP_NONSTICK|WDS_POPUP_AUTOPOP|WDS_POPUP_GRAB_POINTER);
}

