
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

class IWS_DefaultRadioButtonSelectHandler : public IWS_Handler
{
	public:
		IWS_DefaultRadioButtonSelectHandler(void){}
virtual ~IWS_DefaultRadioButtonSelectHandler(void){}

virtual	void HandleEvent(const GPL_String &string)
		{
			wbaLog("IWS WARNING", "[%s] radio button select not handled", 
				(const char *)string);
		}		
};

class IWS_DefaultRadioButtonDeselectHandler : public IWS_Handler
{
	public:
		IWS_DefaultRadioButtonDeselectHandler(void){}
virtual ~IWS_DefaultRadioButtonDeselectHandler(void){}

virtual	void HandleEvent(const GPL_String &string)
		{
			wbaLog("IWS WARNING", "[%s] radio button deselect not handled", 
				(const char *)string);
		}		
};


class IWS_RadioButton : public WDS_RadioButton
{
	private:
		static	IWS_DefaultRadioButtonSelectHandler		defaultSelectHandler;
		static	IWS_DefaultRadioButtonDeselectHandler	defaultDeselectHandler;
	protected:
		WDS_Image *buttonImage;
	public:
		IWS_RadioButton(void);
		IWS_RadioButton(const GPL_String &n);
		void IWS_RadioButtonConstructor(void);
virtual	~IWS_RadioButton(void);

		GPL_Boolean	SetImage(long index);
		GPL_Boolean	SetImage(char **i);
		GPL_Boolean	SetImageFromFile(const GPL_String &f);
virtual	void SetSelectHandler(IWS_Handler *handler, WDS_Activation *actv = NULL);
virtual	void SetDeselectHandler(IWS_Handler *handler, WDS_Activation *actv = NULL);
};

class IWS_ToggleButton : public WDS_ToggleButton
{
	private:
		static	IWS_DefaultRadioButtonSelectHandler		defaultSelectHandler;
		static	IWS_DefaultRadioButtonDeselectHandler	defaultDeselectHandler;
	protected:
		WDS_Image *buttonImage;
	public:
		IWS_ToggleButton(void);
		IWS_ToggleButton(const GPL_String &n);
		void IWS_ToggleButtonConstructor(void);
virtual	~IWS_ToggleButton(void);

		GPL_Boolean	SetImage(long index);
		GPL_Boolean	SetImage(char **i);
		GPL_Boolean	SetImageFromFile(const GPL_String &f);
virtual	void SetSelectHandler(IWS_Handler *handler, WDS_Activation *actv = NULL);
virtual	void SetDeselectHandler(IWS_Handler *handler, WDS_Activation *actv = NULL);
};

class IWS_RadioBar : public WDS_Scope
{
	private:
		WDS_Form	*rootForm;
	public:
		IWS_RadioBar(void);
virtual	~IWS_RadioBar(void);

	WDS_Form	*GetForm(void){ return rootForm; }

	IWS_RadioButton *AddRadio( 	const GPL_String &n, 
							IWS_Handler *sel, IWS_Handler *desel);
	IWS_RadioButton *AddRadio(	const GPL_String &n,
							void (*sel) (WDS_Activation *) =
								(void (*) (WDS_Activation *)) GPL_BAD_ADDRESS,
							WDS_Activation * a =
								(WDS_Activation *) GPL_BAD_ADDRESS,
							void (*desel) (WDS_Activation *) =
								(void (*) (WDS_Activation *)) GPL_BAD_ADDRESS);
	IWS_ToggleButton *AddToggle( 	const GPL_String &n, 
							IWS_Handler *sel, IWS_Handler *desel);
	IWS_ToggleButton *AddToggle(	const GPL_String &n,
							void (*sel) (WDS_Activation *) =
								(void (*) (WDS_Activation *)) GPL_BAD_ADDRESS,
							WDS_Activation * a =
								(WDS_Activation *) GPL_BAD_ADDRESS,
							void (*desel) (WDS_Activation *) =
								(void (*) (WDS_Activation *)) GPL_BAD_ADDRESS);
	WDS_Button *AddButton(WDS_Button *button);
	WDS_Button *FindButton(const GPL_String & n);
};

class IWS_RadioRow : public IWS_RadioBar
{
	private:
	public:
		IWS_RadioRow(void){}
virtual	~IWS_RadioRow(void){}
};

class IWS_RadioColumn : public IWS_RadioBar
{
	private:
	public:
		IWS_RadioColumn(void);
virtual	~IWS_RadioColumn(void){}
};

