
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <iws/iws.h>

IWS_DefaultTipbarHandler IWS_TipBar::defaultHandler;



IWS_TipBar::IWS_TipBar(EW_Window *w)
{
	w->SetWSHandler(this);
	SetMode (WDS_FORM_SINGLE_ROW);
	SetSizing (WDS_HORIZONTAL, WDS_SIZING_MANUAL);
	SetSizing (WDS_VERTICAL, WDS_SIZING_FIT_CHILDREN);
	button.SetHandler(&defaultHandler);

//	GetLocalLook()->SetElement(WDS_STATE_ALL, WDS_ELEMENT_DEPTH, 2);
	SetLocalElement(WDS_STATE_ALL, WDS_ELEMENT_DEPTH, 2);

//	button.SetSizeMode(IWS_SIZE_MODE_WRAP, IWS_SIZE_MODE_WRAP);
	button.SetSizeMode(IWS_SIZE_MODE_FILL, IWS_SIZE_MODE_WRAP);

	button.SetLocalElement(WDS_STATE_0,WDS_ELEMENT_BORDER,WDS_BEVELBOX_BORDERLESS|WDS_BEVELBOX_LABEL_LEFT);

	AddWidget(&button);
}



IWS_TipBar::~IWS_TipBar()
{
}



void IWS_TipBar::SetHandler(IWS_Handler *handler, WDS_Activation *actv)
{
	button.SetHandler(handler, actv);
}



void IWS_TipBar::WSHandle()
{
	if(!(GetEvent()->InWidget(GetWidget())))
	{
		return;
	}

	if(GetWidget()->GetTipMode() == WDS_TIP_ON)
	{
		button.SetLabel(GetWidget()->GetTipText());
		if(button.GetLabelString()->Compare((char *)(button.lastString)))
		{
			button.SetDirty(EW_DIRTY_COMPLETE|EW_DIRTY_PENDING|EW_DIRTY_IF_PENDING);
		}
		else
		{
			button.SetDirty(EW_DIRTY_NOT|EW_DIRTY_IF_PENDING);
		}
	}
	else
	{
		if(!(button.GetDirty() & EW_DIRTY_PENDING))
		{
			button.SetLabel("");
			button.SetDirty(EW_DIRTY_COMPLETE|EW_DIRTY_PENDING|EW_DIRTY_IF_PENDING);
		}
	}
}


