#!/bin/sh

#******************************************************************************
#
# COPYRIGHT_HEADER
#
#------------------------------------- RCS ------------------------------------
#
# $Id: export.sh 1.1 Mon, 01 Mar 1999 22:47:53 -0800 orang $
#
# $Log: export.sh,v $
# Revision 1.3  1997/08/19  23:43:21  mike
# Change to incremental exporting.
#
# Revision 1.2  1997/07/29 19:00:37  mike
# Moving to exporting only "important" revisions
#
#
#******************************************************************************

execute ()
{
	echo "$@"
	$*
}

# Set up the defaults.
USAGE="Usage: $0 -d [dd-month]"
DATE=

# Parse the command-line arguments.
while getopts \?d:h OPT
do
	case $OPT in
	d)		DATE=$OPTARG ;;
	\?|h)	echo $USAGE
		exit 1 ;;
	esac
done

# Date must be provided.
if [ -z "$DATE" ]
then
	echo $USAGE
	exit 1
fi

DIR=`pwd`
for d in `cat ./MODULES`
do
	execute cd ${CVSROOT}/${d}
	execute clearexport_rcs -r -s $DATE -V -o ${DIR}/${d}.cvt *,v
done

