
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <mte/mte.h>

MTE_Group::MTE_Group()
{
}

MTE_Group::~MTE_Group()
{
}

void MTE_Group::Add(MTE_Task *task)
{
	tasklist.AppendNode(task);
}

void MTE_Group::Remove(MTE_Task *task)
{
	tasklist.RemoveNode(task);
}

GPL_Integer MTE_Group::Run()
{
	MTE_Task *task;
	tasklist.ToHead();
	while((task = tasklist.PostIncrement()))
	{
		task->Start();
	}
	tasklist.ToHead();
	while((task = tasklist.PostIncrement()))
	{
		task->Wait();
	}
	tasklist.ToHead();
	while((task = tasklist.PostIncrement()))
	{
		if(task->GetState() == MTE_TASK_DONE)
		{
			Remove(task);
		}
	}

	return tasklist.GetNumberNodes();
}

void MTE_Group::Loop()
{
	while(Run());
}

void MTE_Group::DeleteTasks()
{
	MTE_Task *task;
	tasklist.ToHead();
	while((task = tasklist.PostIncrement()))
	{
		Remove(task);
		delete task;
	}
}

