#ifndef MTE_TASK_H
#define MTE_TASK_H

/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#define MTE_SPROC	1
#define MTE_PTHREAD	2
#define MTE_WIN32	3

#ifdef MTE_THREADING_ENABLED
#if OSD_OS==OSD_SUNOS
#define MTE_IMPL MTE_PTHREAD
#elif OSD_OS==OSD_IRIX
#define MTE_IMPL MTE_PTHREAD
#elif OSD_OS==OSD_WINNT
#define MTE_IMPL MTE_WIN32
#elif OSD_OS==OSD_LINUX
#define MTE_IMPL MTE_PTHREAD
#endif
#endif

#if MTE_IMPL==MTE_SPROC
#include <sys/types.h>
#include <sys/prctl.h>
#include <sys/wait.h>
#elif MTE_IMPL==MTE_PTHREAD
#include <pthread.h>
#elif MTE_IMPL==MTE_WIN32
#else
#endif

#define MTE_TASK_READY		1
#define MTE_TASK_DONE		2

class MTE_Group;

class MTE_Task
{
	private:
static  long total_starts;
static	long active_threads;
		GPL_Integer 	state;
#if MTE_IMPL==MTE_SPROC
		int 			thread;
#elif MTE_IMPL==MTE_PTHREAD
		pthread_attr_t	attr;
		pthread_t 		thread;
#elif MTE_IMPL==MTE_WIN32
		HANDLE			thread;
		DWORD			dwThreadId;
#else
#endif
	public:
		MTE_Task();
virtual	~MTE_Task();

		/* MANAGEMENT */
		GPL_Boolean Start();
		GPL_Boolean Wait();
		GPL_Boolean	Kill();
		GPL_Integer	GetState(){return state;}
		void		SetDetach(GPL_Boolean setting);

		/* THE ACTUAL WORK */
virtual	void Work(void);

	protected:
		/* USE WITHIN CALLBACK */
		void SetKillable(GPL_Boolean setting);
		void Stop();
		void Done();
};

#endif /* MTE_TASK_H */
