#ifndef SPA_ENCRYPT_H
#define SPA_ENCRYPT_H

/******************************************************************************

Coral Tree spa/encrypt.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <gpl/gpl.h>

/******************************************************************************
class SPA_Encrypter

Abstract base class for all encrypters.
******************************************************************************/
class SPA_Encrypter : public GPL_Object
{
	public:
		SPA_Encrypter(void);
		virtual ~SPA_Encrypter(void);

		virtual GPL_Boolean Encrypt(GPL_Block & data);
		virtual GPL_Boolean Encrypt(const GPL_Block & key, GPL_Block & data);
		virtual GPL_Boolean Decrypt(GPL_Block & data);
		virtual GPL_Boolean Decrypt(const GPL_Block & key, GPL_Block & data);

		// GPL_Object
		GPL_OBJECT_ABSTRACT_INTERFACE(SPA_Encrypter);
};

#endif /* SPA_ENCRYPT_H */
