/* A WIDGET SET */

#include "wds.h"

#define EW_KEYPRESS_TEST	FALSE	/* inc/dec chars for press states */


/*
 *								EW_Button
 */

/*****************************************************************************
		EW_Button::EW_Button()

Keywords:
******************************************************************************/
EW_Button::EW_Button()
	{
	DB("EW_Button::EW_Button()");

/* 	label = NULL; */

	displayfunction = NULL;
	displayarg = NULL;
	q=0;
	}



/******************************************************************************
long	EW_Button::Operate(EW_Event *event,void *userdata)

Keywords:
******************************************************************************/
long EW_Button::Operate(EW_Event *event,void *userdata)
	{
	if(!active)
		{
//TODO: why are we checking InWidget when Descend does this for us now
		if(InWidget(event))
			{
			if(event->IsLeftMousePress())
				{
				Activate();
				if(!q)
				{
					q = 1;
				}
				NeedRedraw();
				}
			}
		}
	else
		{
		if( !InWidget(event) )
			{
			DeActivate();
			NeedRedraw();
			}

		if(event->IsLeftMouseRelease())
			{
			DeActivate();
			NeedRedraw();
			}
		}

	return TRUE;
	}



/******************************************************************************
long	EW_Button::Resize(void *userdata)

Keywords:
******************************************************************************/
long EW_Button::Resize(void *userdata)
{
	long resized = FALSE;

	SetTrue();

	if(q == 2)
	{
		q = 0;
		sy-=25;
		resized = TRUE;
	}
	if(q == 1)
	{
		q = 2;
		sy+=25;
		resized = TRUE;
	}

	if(widgetlist->Resize(userdata)) resized = TRUE;

	return resized;
}



/******************************************************************************
void	EW_Button::Draw(EW_Redraw *redraw)

Keywords:
******************************************************************************/
void EW_Button::Draw(EW_Redraw *redraw)
	{
	DB("EW_Button::Draw()");

/* 	ortho2(0,sx,0,sy); */

	root->BevelBox(truex,truey,sx,sy,active? EW_BEVELBOX_IN:EW_BEVELBOX_EVEN,TRUE,&label);

	if(displayfunction)
		{
		long depth=root->GetBevelDepth();

		displayfunction(root,truex+depth,truey+depth,sx-2*depth,sy-2*depth,displayarg);
		}
	}



/******************************************************************************
void	EW_Button::SetLabel(char *a_string)

Keywords:
******************************************************************************/
void EW_Button::SetLabel(char *a_string)
	{
	DB("EW_Button::SetLabel(char *a_string)");

/*
	if(label != NULL)
		free(label);

	label = strdup(a_string);
*/

	if(label.NewString(a_string) == NULL)
		EW_PRINT(EW_OS,EW_ERROR,"could not allocate more memory");
	}



/*
 *								EW_Toggle
 */

/******************************************************************************
		EW_Toggle::EW_Toggle()

Keywords:
******************************************************************************/
EW_Toggle::EW_Toggle()
	{
	DB("EW_Toggle::EW_Toggle()");

/* 	label = NULL; */
	}



/******************************************************************************
long	EW_Toggle::Operate(EW_Event *event,void *userdata)

Keywords:
******************************************************************************/
long EW_Toggle::Operate(EW_Event *event,void *userdata)
	{

	if(InWidget(event) && event->IsLeftMousePress())
		{
		if(!active)
			Activate();
		else
			DeActivate();

		NeedRedraw();
		}

	return FALSE;
	}



/******************************************************************************
void	EW_Toggle::Draw(EW_Redraw *redraw)

Keywords:
******************************************************************************/
void EW_Toggle::Draw(EW_Redraw *redraw)
	{
	DB("EW_Toggle::Draw()");

/* 	ortho2(0,sx,0,sy); */

	root->BevelBox(truex,truey,sx,sy,active? EW_BEVELBOX_IN:EW_BEVELBOX_EVEN,FALSE,&label);
	}



/******************************************************************************
void	EW_Toggle::SetLabel(char *a_string)

Keywords:
******************************************************************************/
void EW_Toggle::SetLabel(char *a_string)
	{
	DB("EW_Toggle::SetLabel(char *a_string)");

/*
	if(label != NULL)
		free(label);

	label = strdup(a_string);
*/

	if(label.NewString(a_string) == NULL)
		EW_PRINT(EW_OS,EW_ERROR,"could not allocate more memory");
	}



/*
 *								EW_GetString
 */

/******************************************************************************
		EW_GetString::EW_GetString()

Keywords:
******************************************************************************/
EW_GetString::EW_GetString()
	{
	DB("EW_GetString::EW_GetString()");

/*
	buffer[0] = '\0';
	string[0] = '\0';
*/

	mode = STRING_MODE;
	callback = NULL;
	c = 0;
	maxlength = STRING_BUFFER - 1;
	}



/******************************************************************************
void	EW_GetString::Activate()

Keywords:
******************************************************************************/
void EW_GetString::Activate()
	{
	DB("EW_GetString::Activate()");

	EW_Widget *next;
	EW_Widget *current;
	EW_WidgetList *parentlist;

	current = this;

	while(current)
		{
		if(current->widget)
			{
			parentlist = current->widget->widgetlist;
			current = current->widget;
			}
		else if(current->window)
			{
			parentlist = current->window->widgetlist;
			current = NULL;
			}
		else
			EW_PRINT(EW_APP,EW_ERROR,"no valid parent widget to EW_GetString");

		parentlist->Rewind();
		while((next = parentlist->Next())!=NULL)
			{
			if(next->Active() == TRUE_EXCLUDE)
				next->DeActivate();
			}
		}

	active = TRUE_EXCLUDE;
	}



/******************************************************************************
void	EW_GetString::DeActivate()

Keywords:
******************************************************************************/
void EW_GetString::DeActivate()
	{
	DB("EW_GetString::DeActivate()");

	active = FALSE;
	c = 0;

/* 	buffer[0] = 0; */
	buffer.NewLength(0);
	}



/******************************************************************************
long	EW_GetString::Operate(EW_Event *event,void *userdata)

Keywords:
******************************************************************************/
long EW_GetString::Operate(EW_Event *event,void *userdata)
	{

	long i;
	short done = FALSE;
	short ok = FALSE;
	long length;

	if(InWidget(event) && event->IsLeftMousePress())
		{
		if(!Active())
			Activate();
		else
			DeActivate();

		NeedRedraw();
		return FALSE;
		}

	// check to see if within parent widget
	if(widget)
		{
		if(!widget->InWidget(event))
			return FALSE;
		}
	else if(!window)
		EW_PRINT(EW_APP,EW_ERROR,"no valid parent widget for EW_GetString");

	length=buffer.Length();

	if(Active())
		{
		switch(event->GetSource())
			{
			case EW_EVENT_KEYBOARD:
/* 				event->Print(NULL); */

				if( event->IsKeyTyped(EW_KEY_ALL) )
					{
					switch(event->GetItem())
						{
						case EW_KEY_ESC:		// ASCII ESC
							done = TRUE;
							break;

						case EW_KEY_RETURN:		// ASCII CR (Return)
							done = TRUE;
							ok = TRUE;
							break;

						case EW_KEY_BACKSPACE:	// ASCII BS (BackSpace)
							if(c>0)
								{
								c--;
								buffer.DeleteChar(c);
								}
							break;

						case EW_KEY_DELETE:		// ASCII rubout (delete)
							if(c!=length)
								{
								buffer.DeleteChar(c);

								}
							break;

						case EW_KEY_CURSOR_UP:
							buffer.NewString(string.String());

							c=0;
							break;

						case EW_KEY_CURSOR_DOWN:
							buffer.NewLength(0);

							c=0;
							break;

						case EW_KEY_CURSOR_LEFT:
							if(c>0)
								c--;
							break;

						case EW_KEY_CURSOR_RIGHT:
							c++;
							if(c>length)
								c=length;
							break;

						default:	// other ascii
/* 							fprintf(stderr,"ASCII %d 0x%x\n",event->GetItem(),event->state[0]); */

							if(length < maxlength - 1)
								{
								if( (event->GetItem()>=32) && (event->GetItem()<127) )
									{
#if EW_KEYPRESS_TEST
									if(event->state[0] & EW_STATE_PRESS)
										event->SetItem( event->GetItem() + 1 );
									if(event->state[0] & EW_STATE_RELEASE)
										event->SetItem( event- >GetItem() - 1 );
#endif

									buffer.InsertChar(c,event->GetItem());
									c++;
									}
								}
							break;
						}
					}
				break;

			default:
				return FALSE;
			}

		if(done)
			{
			if(ok)
				{
				string.NewString(buffer.String());

				if(callback)
					(*callback)(this, string.String());
				}

			DeActivate();
			}

		NeedRedraw();
		}

	return FALSE;
	}



/******************************************************************************
void	EW_GetString::Draw(EW_Redraw *redraw)

Keywords:
******************************************************************************/
void EW_GetString::Draw(EW_Redraw *redraw)
	{
	DB("EW_GetString::Draw()");

/* 	ortho2(0,sx,0,sy); */

	if(Active())
		{
		buffer.SetCursorPosition(c);
		root->BevelBox(truex,truey,sx,sy,EW_BEVELBOX_IN,TRUE,&buffer);
		}
	else
		root->BevelBox(truex,truey,sx,sy,EW_BEVELBOX_EVEN,TRUE,&string);
	}



/******************************************************************************
void	EW_GetString::RegisterCallback(void (*a_callback)(EW_Widget *,char *))

Keywords:
******************************************************************************/
void EW_GetString::RegisterCallback(void (*a_callback)(EW_Widget *,char *))
	{
	DB("EW_GetString::RegisterCallback(void (*a_callback)(EW_Widget *,char *))");

	callback = a_callback;
	}



/******************************************************************************
void	EW_GetString::SetString(char *a_string)

Keywords:
******************************************************************************/
void EW_GetString::SetString(char *a_string)
	{
	DB("EW_GetString::SetString(char *a_string)");

	DeActivate();

/* 	strcpy(string,a_string); */
	string.NewString(a_string);
	}



/*
 *								EW_Blank
 */

/******************************************************************************
		EW_Blank::EW_Blank()

Keywords:
******************************************************************************/
EW_Blank::EW_Blank()
	{
	DB("EW_Blank::EW_Blank()");

	color_index = EW_DEFAULT_BG_COLOR;
	}



/******************************************************************************
void	EW_Blank::Draw(EW_Redraw *redraw)

Keywords:
******************************************************************************/
void EW_Blank::Draw(EW_Redraw *redraw)
	{
	DB("EW_Blank::Draw()");

	root->RectFill(truex,truey,truex+sx,truey+sy,(long)EW_BLUE);
	//root->SetColor(EW_BG_COLOR,color_index);
	//root->Clear();
	}



/******************************************************************************
void	EW_Blank::SetColor(long a_color)

Keywords:
******************************************************************************/
void EW_Blank::SetColor(long a_color)
	{
	DB("EW_Blank::SetColor(long a_color)");

	color_index = a_color;
	}

long EW_Blank::Resize(void *userdata)
{
	long resized = FALSE;

	SetTrue();

	sx = root->sx;
	sy = root->sy;

	if(widgetlist->Resize(userdata)) resized = TRUE;

	return resized;
}



/*
 *								EW_Radio
 */

/******************************************************************************
		EW_Radio::EW_Radio()

Keywords:
******************************************************************************/
EW_Radio::EW_Radio()
	{
	DB("EW_Radio::EW_Radio()");
	}



/******************************************************************************
long 	EW_Radio::Operate(EW_Event *event,void *userdata)

Keywords:
******************************************************************************/
long EW_Radio::Operate(EW_Event *event,void *userdata)
	{
	EW_Widget *next;

	if(InWidget(event))
		{
		if(event->IsLeftMousePress())
			{
			widgetlist->Rewind();
			while( (next = widgetlist->Next()) != NULL )
				next->DeActivate();
			}
		}

	return FALSE;
	}



/******************************************************************************
long	EW_Radio::PostOperate(EW_Event *event,void *userdata)

Keywords:
******************************************************************************/
long EW_Radio::PostOperate(EW_Event *event,void *userdata)
	{
	DB("EW_Radio::PostOperate(EW_Event *event,void *userdata)");

	EW_Widget *next;
	long i = 0;
	
	widgetlist->Rewind();
	while( (next = widgetlist->Next()) != NULL )
		{
		if(next->Active())
			{
			if(i != active_index)
				{
				active_index = i;

				NeedRedraw();
				return FALSE;
				}
			else
				{
				return FALSE;
				}
			}

		i++;
		}

	if(active_index != -1)
		{
		active_index = -1;
		NeedRedraw();
		}

	return FALSE;
	}



/******************************************************************************
long	EW_Radio::ActiveIndex()

Keywords:
******************************************************************************/
long EW_Radio::ActiveIndex()
	{
	DB("EW_Radio::ActiveIndex()");

	return active_index;
	}



/*
 *								EW_NumberEntry
 */

/******************************************************************************
		EW_NumberEntry::EW_NumberEntry()

Keywords:
******************************************************************************/
EW_NumberEntry::EW_NumberEntry()
	{
	DB("EW_NumberEntry::EW_NumberEntry()");

/* 	label = NULL; */
	stepsize = (float)(1.0);
	number = NULL;
	}



/******************************************************************************
void	EW_NumberEntry::Draw(EW_Redraw *redraw)

Keywords:
******************************************************************************/
void EW_NumberEntry::Draw(EW_Redraw *redraw)
	{
	DB("EW_NumberEntry::Draw(EW_Redraw *redraw)");

/* 	ortho2(0,sx,0,sy); */

	root->BevelBox(truex,truey,labelwidth,sy,EW_BEVELBOX_BORDER,FALSE,&label);
	}



/******************************************************************************
void	EW_NumberEntry::SetLabel(char *a_string)

Keywords:
******************************************************************************/
void EW_NumberEntry::SetLabel(char *a_string)
	{
	DB("EW_NumberEntry::SetLabel(char *a_string)");

/*
	if(label != NULL)
		free(label);

	label = strdup(a_string);
*/
	
	if(label.NewString(a_string) == NULL)
		EW_PRINT(EW_OS,EW_ERROR,"could not allocate more memory");
	}



/******************************************************************************
void EW_NumberEntry::SetUp(long x,long y,long w,long h,
													long field_w,long button_w)

Keywords:
******************************************************************************/
void EW_NumberEntry::SetUp(long x,long y,long w,long h,long field_w, long button_w)
	{
	char tmp[STRING_BUFFER];

	SetGeometry(x,y,w,h);

	AddWidget(&string_entry);
	AddWidget(&incr_button);
	AddWidget(&decr_button);

	string_entry.SetGeometry(	w - 2*button_w - field_w,
								0,
								field_w,
								h);

	string_entry.RegisterCallback(ewNumberEntry_GetStringCallback);

	sprintf(tmp,"%f",*number);
	string_entry.SetString(tmp);

	incr_button.SetGeometry(	w - 2*button_w,
								0,
								button_w,
								h);

	decr_button.SetGeometry(    w - button_w,
								0,
								button_w,
								h);

	/* width of text label (note extra space) */
	labelwidth=sx-field_w-2*button_w-root->GetBevelDepth();
	}



/******************************************************************************
void	EW_IncrButton::Activate(void)

Keywords:
******************************************************************************/
void EW_IncrButton::Activate(void)
	{
	DB("EW_IncrButton::Activate(void)");

	active = TRUE;

	((EW_NumberEntry *)widget)->Increment();
	}



/******************************************************************************
void	EW_DecrButton::Activate(void)

Keywords:
******************************************************************************/
void EW_DecrButton::Activate(void)
	{
	DB("EW_DecrButton::Activate(void)");

	active = TRUE;

	((EW_NumberEntry *)widget)->Decrement();
	}



/******************************************************************************
void	ewNumberEntry_GetStringCallback(EW_Widget *string_widget,
																char *a_string)

Keywords:
******************************************************************************/
/*PROTOTYPE*/
void ewNumberEntry_GetStringCallback(EW_Widget *string_widget, char *a_string)
	{
	char tmp[STRING_BUFFER];

	EW_NumberEntry *tmp_num_entry;

	tmp_num_entry = (EW_NumberEntry *)(string_widget->widget);
	tmp_num_entry->SetNumberValue(atof(a_string));

	sprintf(tmp,"%f",*(tmp_num_entry->GetNumber()));
	((EW_GetString *)string_widget)->SetString(tmp);
	}



/******************************************************************************
void	EW_NumberEntry::Increment()

Keywords:
******************************************************************************/
void EW_NumberEntry::Increment()
	{
	DB("EW_NumberEntry::Increment()");

	char tmp[STRING_BUFFER];
	
	if(number)
		*number += stepsize;

	sprintf(tmp,"%f",*number);
	string_entry.SetString(tmp);

	NeedRedraw();
	}



/******************************************************************************
void	EW_NumberEntry::Decrement()

Keywords:
******************************************************************************/
void EW_NumberEntry::Decrement()
	{
	DB("EW_NumberEntry::Decrement()");

	char tmp[STRING_BUFFER];

	if(number)
		*number -= stepsize;

	sprintf(tmp,"%f",*number);
	string_entry.SetString(tmp);

	NeedRedraw();
	}



/*
 *						Some Display Functions 
 */

/******************************************************************************
void	ewUpArrow(EW_Window *window,long ix,long iy,long sx,long sy,
																void *dummy)

Keywords:
******************************************************************************/
/*PROTOTYPE*/
void ewDfUpArrow(EW_Window *window,long ix,long iy,long sx,long sy,void *dummy)
	{
	long vert[3][2];

	vert[0][0]=ix+sx*0.2;
	vert[0][1]=iy+sy*0.2;

	vert[1][0]=ix+sx*0.8;
	vert[1][1]=iy+sy*0.2;

	vert[2][0]=ix+sx*0.5;
	vert[2][1]=iy+sy*0.8;

	window->TriangleFill(vert[0],vert[1],vert[2]);
	}



/******************************************************************************
void	ewDfDownArrow(EW_Window *window,long ix,long iy,long sx,long sy,
																void *dummy)

Keywords:
******************************************************************************/
/*PROTOTYPE*/
void ewDfDownArrow(EW_Window *window,long ix,long iy,long sx,long sy,void *dummy)
	{
	long vert[3][2];

	vert[0][0]=ix+sx*0.2;
	vert[0][1]=iy+sy*0.8;

	vert[1][0]=ix+sx*0.8;
	vert[1][1]=iy+sy*0.8;

	vert[2][0]=ix+sx*0.5;
	vert[2][1]=iy+sy*0.2;

	window->TriangleFill(vert[0],vert[1],vert[2]);
	}

