#ifndef DNA_INSTRUCT_H
#define DNA_INSTRUCT_H

/******************************************************************************

Coral Tree dna/instruct.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <gpl/gpl.h>

/******************************************************************************
enum DNA_Instruction 

Client-server instructions.
******************************************************************************/
enum DNA_Instruction
{
	// Delivery test
	DNA_INSTRUCTION_NOP			= 0x00,

	// Health verification
	DNA_INSTRUCTION_PING		= 0x01,

	// Shutdown request from client
	DNA_INSTRUCTION_SHUTDOWN	= 0x02,

	// Sign-off notification from server
	DNA_INSTRUCTION_SIGNOFF		= 0x03,

	// Connection request from client
	DNA_INSTRUCTION_CONNECT		= 0x04,

	// Disconnection request from client
	DNA_INSTRUCTION_DISCONNECT	= 0x05,

	// Last instruction
	DNA_INSTRUCTION_LAST		= 0x06
};

GPL_String dnaInstructionToString(const DNA_Instruction i);

#endif /* DNA_INSTRUCT_H */
