#ifndef DNA_SERVER_H
#define DNA_SERVER_H

/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

/******************************************************************************
DNA_Server provides the interface to a sever that waits for connections
on a particular socket, creates a new socket for each connection (accept),
and services requests on said sockets.
******************************************************************************/

#define	DNA_GET_HANDLE(x)	((DNA_TCPConnectionImp *) (x).GetConnectionImp())->GetSocketHandle()

class DNA_Server
{
	public:
		DNA_Server(void);
virtual	~DNA_Server(void) {}

virtual	GPL_Boolean	Initialize(void);
virtual	void 		Finalize(void);

virtual	void Wait(void) = 0;
	protected:
		DNA_Point *GetSource(void) const { return connection.GetSource(); }
		DNA_ConnectionImp *GetConnectionImp(void) const
			{ return connection.GetConnectionImp(); }
		void SetSource(DNA_IPPoint *s) { connection.SetSource(s); }
		void SetImp(DNA_UDPBindingImp *i) { connection.SetImp(i); }

virtual	void ProcessMessage(DNA_Message & message, const GPL_Opaque key)
		{
			message = message;
			GPL_Opaque k;
			k = key;
		}
virtual void AcceptGoodConnection(const GPL_Opaque key)
		{
			GPL_Opaque k;
			k = key;
		}
virtual void DropBadConnection(const GPL_Opaque key) { Reject(key); }
virtual	GPL_Boolean Request(DNA_Message & message, const GPL_Opaque key);
virtual	GPL_Boolean Reply(DNA_Message & message, const GPL_Opaque key);
virtual	void Reject(const GPL_Opaque key);
	protected:
		DNA_Connection connection;
		GPL_Map<SOCKET_HANDLE, DNA_Connection> connections;

	private:
		// No passing around of servers.
		DNA_Server(const DNA_Server & server);
		DNA_Server & operator=(const DNA_Server & server);

		static unsigned long HashFunction(const SOCKET_HANDLE & key) 
			{ return (unsigned long) key; }

};

#endif /* DNA_SERVER_H */

